import processing.serial.*;

Serial myPort;  // Create object from Serial class
int val;      // Data received from the serial port
int []smooth = new int[3];
int smoothed_val;//Smooth out the data
int []value = new int[600];
int count = 0;

PrintWriter output;

void setup() 
{
  size(600, 600);
  //String portName = Serial.list()[0];
  //port = new Serial( this, portName, 9600 );
  //
  //port = new Serial( this, "COM1", 9600 );//Windows
  myPort = new Serial(this, "/dev/tty.usbserial-FTGCKCJC", 9600);//Mac

  String file_name = "data/"+ str(month()) + str(day()) + str(hour()) + str(minute()) + str(second())+ ".csv";
  output = createWriter(file_name);
  for (int i = 0; i < value.length; i++) {
    value[i] = height/2;
  }
}

void draw()
{

  for (int i = 0; i < value.length-1; i++) {
    value[i] = value[i+1];
  }
  if ( myPort.available() > 0) {  // If data is available,

    val = myPort.read();         // read it and store it in val
    smooth[2] = smooth[1];
    smooth[1] = smooth[0];
    smooth[0] = val;
    smoothed_val = (smooth[2]+smooth[1]+smooth[0])/3;
    value[value.length-1] = (int)map(smoothed_val,40,60,0,255);
    println(smoothed_val, value[value.length-1]);
    float time = millis();
    output.println(time/1000 + "," + smoothed_val);
  }

  background(0);
  stroke(255);
  for (int i = 0; i < value.length-1; i++)
  {
    line( i, value[i]+height/2, i+1, value[i+1]+height/2);
  }
  fill(150,0,0);
  noStroke();
  ellipse(width/2,height/3,smoothed_val*5,smoothed_val*5);
}

void mouseClicked() {
  output.flush();
  output.close();
}

